import { api } from '@/utils/api'
import QsUtil from '@/utils/QsUtil'

export default class CurdApi {
  basePath

  getList = (query) => api({
    url: `${this.basePath}${QsUtil.stringify(query)}`,
    method: 'GET'
  })

  getPagination = (query, pagination) => api({
    url: `${this.basePath}/page${QsUtil.stringify(Object.assign({}, query, pagination))}`,
    method: 'GET'
  })

  getDetail = (data, target) => api({
    url: `${this.basePath}/${data[target.$$idProp]}`,
    method: 'GET'
  })

  save = (data, saveType, target) => {

  }

  delete = (data, target) => api({
    url: `${this.basePath}/${data[target.$$idProp]}`,
    method: 'DELETE'
  })

  constructor (basePath) {
    this.basePath = basePath
  }
}
